# coding: utf-8

"""
    FeersumNLU API

    This is the HTTP API for Feersum NLU. See https://github.com/praekelt/feersum-nlu-api-wrappers for examples of how to use the API.  # noqa: E501

    OpenAPI spec version: 2.0.45
    Contact: nlu@feersum.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from feersum_nlu.api_client import ApiClient


class CrfEntityExtractorsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def crf_entity_extractor_add_testing_samples(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Add testing samples.  # noqa: E501

        Add testing samples to named extractor. Returns the samples added to the model.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_add_testing_samples(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_add_testing_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_add_testing_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_add_testing_samples_with_http_info(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Add testing samples.  # noqa: E501

        Add testing samples to named extractor. Returns the samples added to the model.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_add_testing_samples_with_http_info(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'crf_sample_list', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_add_testing_samples" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_add_testing_samples`")  # noqa: E501
        # verify the required parameter 'crf_sample_list' is set
        if ('crf_sample_list' not in params or
                params['crf_sample_list'] is None):
            raise ValueError("Missing the required parameter `crf_sample_list` when calling `crf_entity_extractor_add_testing_samples`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'crf_sample_list' in params:
            body_params = params['crf_sample_list']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/testing_samples', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_add_training_samples(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Add training samples.  # noqa: E501

        Add training samples to named extractor. Returns the samples added to the model.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_add_training_samples(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_add_training_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_add_training_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_add_training_samples_with_http_info(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Add training samples.  # noqa: E501

        Add training samples to named extractor. Returns the samples added to the model.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_add_training_samples_with_http_info(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'crf_sample_list', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_add_training_samples" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_add_training_samples`")  # noqa: E501
        # verify the required parameter 'crf_sample_list' is set
        if ('crf_sample_list' not in params or
                params['crf_sample_list'] is None):
            raise ValueError("Missing the required parameter `crf_sample_list` when calling `crf_entity_extractor_add_training_samples`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'crf_sample_list' in params:
            body_params = params['crf_sample_list']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/training_samples', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_create(self, create_details, **kwargs):  # noqa: E501
        """Create a crf entity extractor.  # noqa: E501

        Create a new crf entity extractor or reload one from the trash.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_create(create_details, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CrfEntityExtractorCreateDetails create_details: The details of the instance to create. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_create_with_http_info(create_details, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_create_with_http_info(create_details, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_create_with_http_info(self, create_details, **kwargs):  # noqa: E501
        """Create a crf entity extractor.  # noqa: E501

        Create a new crf entity extractor or reload one from the trash.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_create_with_http_info(create_details, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CrfEntityExtractorCreateDetails create_details: The details of the instance to create. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['create_details', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_create" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'create_details' is set
        if ('create_details' not in params or
                params['create_details'] is None):
            raise ValueError("Missing the required parameter `create_details` when calling `crf_entity_extractor_create`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'create_details' in params:
            body_params = params['create_details']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CrfEntityExtractorInstanceDetail',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_del(self, instance_name, **kwargs):  # noqa: E501
        """Delete named instance.  # noqa: E501

        Delete and get the details of the named crf entity extractor instance. Deleted models can be reloaded from the trash with the create operation.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_del_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_del_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_del_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Delete named instance.  # noqa: E501

        Delete and get the details of the named crf entity extractor instance. Deleted models can be reloaded from the trash with the create operation.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_del" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_del`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CrfEntityExtractorInstanceDetail',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_del_testing_samples(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Delete testing samples.  # noqa: E501

        Delete the listed testing samples of the named extractor. Returns the deleted samples.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_testing_samples(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_del_testing_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_del_testing_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_del_testing_samples_with_http_info(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Delete testing samples.  # noqa: E501

        Delete the listed testing samples of the named extractor. Returns the deleted samples.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_testing_samples_with_http_info(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'crf_sample_list', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_del_testing_samples" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_del_testing_samples`")  # noqa: E501
        # verify the required parameter 'crf_sample_list' is set
        if ('crf_sample_list' not in params or
                params['crf_sample_list'] is None):
            raise ValueError("Missing the required parameter `crf_sample_list` when calling `crf_entity_extractor_del_testing_samples`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'crf_sample_list' in params:
            body_params = params['crf_sample_list']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/testing_samples', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_del_testing_samples_all(self, instance_name, **kwargs):  # noqa: E501
        """Delete all testing samples.  # noqa: E501

        Delete all testing samples of the named extractor. Returns the deleted samples.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_testing_samples_all(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_del_testing_samples_all_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_del_testing_samples_all_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_del_testing_samples_all_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Delete all testing samples.  # noqa: E501

        Delete all testing samples of the named extractor. Returns the deleted samples.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_testing_samples_all_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_del_testing_samples_all" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_del_testing_samples_all`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/testing_samples_all', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_del_training_samples(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Delete training samples.  # noqa: E501

        Delete the listed training samples of the named extractor. Returns the deleted samples.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_training_samples(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_del_training_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_del_training_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_del_training_samples_with_http_info(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Delete training samples.  # noqa: E501

        Delete the listed training samples of the named extractor. Returns the deleted samples.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_training_samples_with_http_info(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'crf_sample_list', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_del_training_samples" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_del_training_samples`")  # noqa: E501
        # verify the required parameter 'crf_sample_list' is set
        if ('crf_sample_list' not in params or
                params['crf_sample_list'] is None):
            raise ValueError("Missing the required parameter `crf_sample_list` when calling `crf_entity_extractor_del_training_samples`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'crf_sample_list' in params:
            body_params = params['crf_sample_list']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/training_samples', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_del_training_samples_all(self, instance_name, **kwargs):  # noqa: E501
        """Delete all training samples.  # noqa: E501

        Delete all training samples of the named extractor. Returns the deleted samples.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_training_samples_all(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_del_training_samples_all_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_del_training_samples_all_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_del_training_samples_all_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Delete all training samples.  # noqa: E501

        Delete all training samples of the named extractor. Returns the deleted samples.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_del_training_samples_all_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_del_training_samples_all" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_del_training_samples_all`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/training_samples_all', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_get_details(self, instance_name, **kwargs):  # noqa: E501
        """Get details of named instance.  # noqa: E501

        Get the details of the named crf entity extractor instance.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_details(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_get_details_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_get_details_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_get_details_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Get details of named instance.  # noqa: E501

        Get the details of the named crf entity extractor instance.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_details_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_get_details" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_get_details`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CrfEntityExtractorInstanceDetail',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_get_details_all(self, **kwargs):  # noqa: E501
        """Get list of loaded crf entity extractors.  # noqa: E501

        Get the list of loaded crf entity extractors.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_details_all(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str x_caller:
        :param str origin:
        :return: list[CrfEntityExtractorInstanceDetail]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_get_details_all_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_get_details_all_with_http_info(**kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_get_details_all_with_http_info(self, **kwargs):  # noqa: E501
        """Get list of loaded crf entity extractors.  # noqa: E501

        Get the list of loaded crf entity extractors.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_details_all_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str x_caller:
        :param str origin:
        :return: list[CrfEntityExtractorInstanceDetail]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_get_details_all" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfEntityExtractorInstanceDetail]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_get_labels(self, instance_name, **kwargs):  # noqa: E501
        """Get list of possible labels.  # noqa: E501

        Returns the extractor's list of possible entity labels.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_labels(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: list[ClassLabel]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_get_labels_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_get_labels_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_get_labels_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Get list of possible labels.  # noqa: E501

        Returns the extractor's list of possible entity labels.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_labels_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: list[ClassLabel]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_get_labels" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_get_labels`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/labels', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[ClassLabel]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_get_params(self, instance_name, **kwargs):  # noqa: E501
        """Get the editable model parameters of named crf entity extractor.  # noqa: E501

        Get the editable model parameters of named crf entity extractor.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_params(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: ModelParams
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_get_params_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_get_params_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_get_params_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Get the editable model parameters of named crf entity extractor.  # noqa: E501

        Get the editable model parameters of named crf entity extractor.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_params_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: ModelParams
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_get_params" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_get_params`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/params', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ModelParams',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_get_testing_samples(self, instance_name, **kwargs):  # noqa: E501
        """Get testing samples.  # noqa: E501

        Get the testing samples of the named extractor.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_testing_samples(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :param int index: The sample index to start from.
        :param int len: The number of samples to return.
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_get_testing_samples_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_get_testing_samples_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_get_testing_samples_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Get testing samples.  # noqa: E501

        Get the testing samples of the named extractor.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_testing_samples_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :param int index: The sample index to start from.
        :param int len: The number of samples to return.
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin', 'index', 'len']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_get_testing_samples" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_get_testing_samples`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []
        if 'index' in params:
            query_params.append(('index', params['index']))  # noqa: E501
        if 'len' in params:
            query_params.append(('len', params['len']))  # noqa: E501

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/testing_samples', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_get_training_samples(self, instance_name, **kwargs):  # noqa: E501
        """Get training samples.  # noqa: E501

        Get the training samples of the named extractor.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_training_samples(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :param int index: The sample index to start from.
        :param int len: The number of samples to return.
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_get_training_samples_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_get_training_samples_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_get_training_samples_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Get training samples.  # noqa: E501

        Get the training samples of the named extractor.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_get_training_samples_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :param int index: The sample index to start from.
        :param int len: The number of samples to return.
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin', 'index', 'len']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_get_training_samples" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_get_training_samples`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []
        if 'index' in params:
            query_params.append(('index', params['index']))  # noqa: E501
        if 'len' in params:
            query_params.append(('len', params['len']))  # noqa: E501

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/training_samples', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_retrieve(self, instance_name, text_input, **kwargs):  # noqa: E501
        """Predict which entities was mentioned.  # noqa: E501

        Predict which entities was mentioned.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_retrieve(instance_name, text_input, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param TextInput text_input: The input text. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfEntity]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_retrieve_with_http_info(instance_name, text_input, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_retrieve_with_http_info(instance_name, text_input, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_retrieve_with_http_info(self, instance_name, text_input, **kwargs):  # noqa: E501
        """Predict which entities was mentioned.  # noqa: E501

        Predict which entities was mentioned.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_retrieve_with_http_info(instance_name, text_input, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param TextInput text_input: The input text. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfEntity]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'text_input', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_retrieve" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_retrieve`")  # noqa: E501
        # verify the required parameter 'text_input' is set
        if ('text_input' not in params or
                params['text_input'] is None):
            raise ValueError("Missing the required parameter `text_input` when calling `crf_entity_extractor_retrieve`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'text_input' in params:
            body_params = params['text_input']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/retrieve', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfEntity]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_set_params(self, instance_name, model_params, **kwargs):  # noqa: E501
        """Set the model parameters of named crf entity extractor.  # noqa: E501

        Set the model parameters of named crf entity extractor.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_set_params(instance_name, model_params, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param ModelParams model_params: The model parameters. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_set_params_with_http_info(instance_name, model_params, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_set_params_with_http_info(instance_name, model_params, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_set_params_with_http_info(self, instance_name, model_params, **kwargs):  # noqa: E501
        """Set the model parameters of named crf entity extractor.  # noqa: E501

        Set the model parameters of named crf entity extractor.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_set_params_with_http_info(instance_name, model_params, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param ModelParams model_params: The model parameters. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'model_params', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_set_params" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_set_params`")  # noqa: E501
        # verify the required parameter 'model_params' is set
        if ('model_params' not in params or
                params['model_params'] is None):
            raise ValueError("Missing the required parameter `model_params` when calling `crf_entity_extractor_set_params`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'model_params' in params:
            body_params = params['model_params']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/params', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CrfEntityExtractorInstanceDetail',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_train(self, instance_name, train_details, **kwargs):  # noqa: E501
        """Train the named crf extractor.  # noqa: E501

        Train the named crf extractor with the training and testing data already provided. Returns the updated instance details.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_train(instance_name, train_details, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param TrainDetails train_details: The arguments provided to the train operation. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_train_with_http_info(instance_name, train_details, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_train_with_http_info(instance_name, train_details, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_train_with_http_info(self, instance_name, train_details, **kwargs):  # noqa: E501
        """Train the named crf extractor.  # noqa: E501

        Train the named crf extractor with the training and testing data already provided. Returns the updated instance details.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_train_with_http_info(instance_name, train_details, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param TrainDetails train_details: The arguments provided to the train operation. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'train_details', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_train" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_train`")  # noqa: E501
        # verify the required parameter 'train_details' is set
        if ('train_details' not in params or
                params['train_details'] is None):
            raise ValueError("Missing the required parameter `train_details` when calling `crf_entity_extractor_train`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'train_details' in params:
            body_params = params['train_details']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/train', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CrfEntityExtractorInstanceDetail',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_update_testing_samples(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Update testing samples by UUID.  # noqa: E501

        Update training samples of the named text classifier. A sample's UUIDs is used to uniquely identify it. Returns the samples that were updated.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_update_testing_samples(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. A sample's UUIDs is used to uniquely identify it. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_update_testing_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_update_testing_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_update_testing_samples_with_http_info(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Update testing samples by UUID.  # noqa: E501

        Update training samples of the named text classifier. A sample's UUIDs is used to uniquely identify it. Returns the samples that were updated.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_update_testing_samples_with_http_info(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. A sample's UUIDs is used to uniquely identify it. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'crf_sample_list', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_update_testing_samples" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_update_testing_samples`")  # noqa: E501
        # verify the required parameter 'crf_sample_list' is set
        if ('crf_sample_list' not in params or
                params['crf_sample_list'] is None):
            raise ValueError("Missing the required parameter `crf_sample_list` when calling `crf_entity_extractor_update_testing_samples`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'crf_sample_list' in params:
            body_params = params['crf_sample_list']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/testing_samples', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_update_training_samples(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Update training samples by UUID.  # noqa: E501

        Update training samples of the named text classifier. A sample's UUIDs is used to uniquely identify it. Returns the samples that were updated.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_update_training_samples(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. A sample's UUIDs is used to uniquely identify it. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_update_training_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_update_training_samples_with_http_info(instance_name, crf_sample_list, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_update_training_samples_with_http_info(self, instance_name, crf_sample_list, **kwargs):  # noqa: E501
        """Update training samples by UUID.  # noqa: E501

        Update training samples of the named text classifier. A sample's UUIDs is used to uniquely identify it. Returns the samples that were updated.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_update_training_samples_with_http_info(instance_name, crf_sample_list, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param list[CrfSample] crf_sample_list: List of crf samples. A sample's UUIDs is used to uniquely identify it. (required)
        :param str x_caller:
        :param str origin:
        :return: list[CrfSample]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'crf_sample_list', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_update_training_samples" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_update_training_samples`")  # noqa: E501
        # verify the required parameter 'crf_sample_list' is set
        if ('crf_sample_list' not in params or
                params['crf_sample_list'] is None):
            raise ValueError("Missing the required parameter `crf_sample_list` when calling `crf_entity_extractor_update_training_samples`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'crf_sample_list' in params:
            body_params = params['crf_sample_list']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/training_samples', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[CrfSample]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def crf_entity_extractor_vaporise(self, instance_name, **kwargs):  # noqa: E501
        """Vaporise the named model.  # noqa: E501

        Permanently vaporises a model even if not trashed.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_vaporise(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.crf_entity_extractor_vaporise_with_http_info(instance_name, **kwargs)  # noqa: E501
        else:
            (data) = self.crf_entity_extractor_vaporise_with_http_info(instance_name, **kwargs)  # noqa: E501
            return data

    def crf_entity_extractor_vaporise_with_http_info(self, instance_name, **kwargs):  # noqa: E501
        """Vaporise the named model.  # noqa: E501

        Permanently vaporises a model even if not trashed.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.crf_entity_extractor_vaporise_with_http_info(instance_name, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str instance_name: The name of the model instance. (required)
        :param str x_caller:
        :param str origin:
        :return: CrfEntityExtractorInstanceDetail
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['instance_name', 'x_caller', 'origin']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method crf_entity_extractor_vaporise" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'instance_name' is set
        if ('instance_name' not in params or
                params['instance_name'] is None):
            raise ValueError("Missing the required parameter `instance_name` when calling `crf_entity_extractor_vaporise`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'instance_name' in params:
            path_params['instance_name'] = params['instance_name']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_caller' in params:
            header_params['X-CALLER'] = params['x_caller']  # noqa: E501
        if 'origin' in params:
            header_params['Origin'] = params['origin']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['APIKeyHeader', 'APIKeyHeader_old']  # noqa: E501

        return self.api_client.call_api(
            '/crf_entity_extractors/{instance_name}/vaporise', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CrfEntityExtractorInstanceDetail',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
